// Test of Scanner
#include <iostream>
#include "ExprParser.h"

using namespace std;

int main() {
    string inputLine;
    Parser parser;
    while (true) {
        cout << "Enter a line:" << endl;
        // cin >> inputLine; // inputs a single word only
        getline(cin, inputLine);
        if (!cin.good() || inputLine == "q")
            break;
        parser.init(inputLine.c_str());
        string message;
        if (parser.parse(message)) {
            cout << "Line is parsed successfully!" << endl;
        } else {
            cout << message << endl;
            continue;
        }
        
        // Print RPN
        for (size_t i = 0; i < parser.rpn.size(); ++i) {
            cout << parser.rpn[i] << endl;
        }
        
        double res = parser.evaluate(2., 3.); // x == 2., y == 3.
        cout << "= " << res << endl;
    }
    return 0;
}
